import { SvelteComponentTyped } from "svelte";
import * as THREE from "three";
import type { Wrapping, TextureFilter, TextureDataType, TextureEncoding } from 'three/src/constants.js';
import type { DepthTexture } from 'three/src/textures/DepthTexture.js';
declare const __propDef: {
    props: {
        id?: string | undefined;
        envMap?: THREE.Texture | null | undefined;
        size?: number | undefined;
        wrapS?: Wrapping | undefined;
        wrapT?: Wrapping | undefined;
        magFilter?: TextureFilter | undefined;
        minFilter?: TextureFilter | undefined;
        format?: number | undefined;
        type?: TextureDataType | undefined;
        anisotropy?: number | undefined;
        depthBuffer?: boolean | undefined;
        stencilBuffer?: boolean | undefined;
        generateMipmaps?: boolean | undefined;
        depthTexture?: DepthTexture | undefined;
        encoding?: TextureEncoding | undefined;
        near?: number | undefined;
        far?: number | undefined;
        background?: boolean | "only" | undefined;
        path?: string | undefined;
        files?: string[] | undefined;
    };
    events: {
        [evt: string]: CustomEvent<any>;
    };
    slots: {
        default: {
            envMap: THREE.Texture | null;
        };
    };
};
export type CubeCameraProps = typeof __propDef.props;
export type CubeCameraEvents = typeof __propDef.events;
export type CubeCameraSlots = typeof __propDef.slots;
export default class CubeCamera extends SvelteComponentTyped<CubeCameraProps, CubeCameraEvents, CubeCameraSlots> {
}
export {};
