import { SvelteComponentTyped } from "svelte";
import * as THREE from 'three';
import * as defaults from '../../utils/defaults.js';
declare const __propDef: {
    props: {
        id?: string | undefined;
        geometry?: THREE.BufferGeometry | undefined;
        material?: THREE.Material | undefined;
        position?: [number, number, number] | undefined;
        rotation?: [number, number, number, (defaults.EulerOrder | undefined)?] | undefined;
        scale?: number | [number, number, number] | undefined;
        castShadow?: boolean | undefined;
        receiveShadow?: boolean | undefined;
        frustumCulled?: boolean | undefined;
        renderOrder?: number | undefined;
        isInterative?: boolean | undefined;
        group?: THREE.Group | null | undefined;
    };
    events: {
        mouseover: CustomEvent<any>;
        mouseout: CustomEvent<any>;
        mousedown: CustomEvent<any>;
        mouseup: CustomEvent<any>;
        click: CustomEvent<any>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {};
};
export type MeshProps = typeof __propDef.props;
export type MeshEvents = typeof __propDef.events;
export type MeshSlots = typeof __propDef.slots;
export default class Mesh extends SvelteComponentTyped<MeshProps, MeshEvents, MeshSlots> {
}
export {};
