import { SvelteComponentTyped } from "svelte";
import * as THREE from 'three';
import * as defaults from '../../utils/defaults.js';
declare const __propDef: {
    props: {
        id?: string | undefined;
        material?: THREE.SpriteMaterial | undefined;
        center?: THREE.Vector2 | undefined;
        isInterative?: boolean | undefined;
        sprite?: THREE.Sprite | undefined;
        position?: [number, number, number] | undefined;
        rotation?: [number, number, number, (defaults.EulerOrder | undefined)?] | undefined;
        scale?: number | [number, number, number] | undefined;
        group?: THREE.Group | null | undefined;
    };
    events: {
        mouseover: CustomEvent<any>;
        mouseout: CustomEvent<any>;
        mousedown: CustomEvent<any>;
        mouseup: CustomEvent<any>;
        click: CustomEvent<any>;
    } & {
        [evt: string]: CustomEvent<any>;
    };
    slots: {};
};
export type SpriteProps = typeof __propDef.props;
export type SpriteEvents = typeof __propDef.events;
export type SpriteSlots = typeof __propDef.slots;
export default class Sprite extends SvelteComponentTyped<SpriteProps, SpriteEvents, SpriteSlots> {
}
export {};
