import { createEventDispatcher } from 'svelte';
import { get_scroll } from "../utils/context";
export class ScrollControls {
    el;
    eps = 0.00001;
    fill;
    fixed;
    horizontal = false;
    damping = 4;
    offset = 0;
    delta = 0;
    pages = 1;
    constructor(horizontal, damping, pages, eps) {
        this.horizontal = horizontal;
        this.damping = damping;
        this.pages = pages;
        this.eps = eps;
    }
    range = (from, distance, margin = 0) => {
        const start = from - margin;
        const end = start + distance + margin * 2;
        return this.offset < start ? 0 : this.offset > end ? 1 : (this.offset - start) / (end - start);
    };
    curve = (from, distance, margin = 0) => {
        return Math.sin(this.range(from, distance, margin) * Math.PI);
    };
    visible = (from, distance, margin = 0) => {
        const start = from - margin;
        const end = start + distance + margin * 2;
        return this.offset >= start && this.offset <= end;
    };
}
