import * as THREE from 'three';
import type { Camera, Object3d, ControlCamera } from './objects';
import type { EffectComposer } from 'three/examples/jsm/postprocessing/EffectComposer.js';
import type { RaycasterManager } from './raycaster.js';
import type { Object3D, WebGLRenderer, LoadingManager } from "three";
export declare class ElementScene {
    scene: THREE.Scene;
    el?: HTMLElement;
    canvas: HTMLCanvasElement | HTMLElement | undefined;
    camera?: Camera;
    orbitControl?: ControlCamera;
    renderer?: WebGLRenderer;
    composer?: EffectComposer;
    onComposer: boolean;
    raycaster?: RaycasterManager;
    position: THREE.Vector2;
    w: number;
    h: number;
    devicePixelRatio: number;
    id: string;
    constructor(id: string, scene: THREE.Scene);
    setControl: () => void;
    update: (w: number, h: number) => void;
}
export declare class ContextCanvas {
    arrayScenes: Map<string, ElementScene>;
    camera?: Camera;
    object3d: Object3d[];
    object: Object3D[];
    renderer?: WebGLRenderer;
    onComposer: boolean;
    manager?: LoadingManager;
    invalidate: () => void;
    before_render: Array<() => void>;
    frame: number;
    frameloop: 'always' | 'demand' | 'never';
    el?: HTMLElement;
    container?: HTMLElement;
    clock: THREE.Clock;
    devicePixelRatio: number;
    w: number;
    h: number;
    constructor(invalidate: () => void, frameloop: 'always' | 'demand' | 'never');
    addBeforeRender: (fn: () => void) => void;
    setFrameloop: (frameloop?: 'always' | 'demand' | 'never') => void;
    addElementScene: () => void;
}
