import * as THREE from 'three';
export class ElementScene {
    scene;
    el;
    canvas;
    camera;
    orbitControl;
    renderer;
    composer;
    onComposer = false;
    raycaster;
    position = new THREE.Vector2(10000, 10000);
    w = 0;
    h = 0;
    devicePixelRatio = 0;
    id;
    constructor(id, scene) {
        this.id = id;
        this.scene = scene;
    }
    setControl = () => {
        if (this.orbitControl && this.camera && this.renderer && this.el) {
            this.orbitControl.Callback(this.camera.target, this.el);
        }
    };
    update = (w, h) => {
        this.w = w;
        this.h = h;
        this.devicePixelRatio = w / h;
        this.camera?.resize(w, h);
        if (this.composer != null) {
            this.composer.setSize(w, h);
        }
    };
}
export class ContextCanvas {
    arrayScenes = new Map();
    //arrayScenes = new Map<string,ElementScene >();
    //arrayScenes : {[id: string] : ElementScene; } = {};
    //scene :Scene
    //scenes :Scene [] = []
    camera;
    object3d;
    object;
    //orbitControl? : ControlCamera
    renderer;
    //composer? : EffectComposer
    onComposer = false;
    manager;
    invalidate;
    before_render;
    frame = 0;
    frameloop;
    el;
    container;
    clock = new THREE.Clock();
    devicePixelRatio = 0;
    w = 0;
    h = 0;
    //canvasClientX =0
    //canvasClientY=0
    constructor(invalidate, frameloop) {
        this.scene = new THREE.Scene();
        this.invalidate = invalidate;
        this.object3d = [];
        this.object = [];
        this.before_render = [];
        this.frameloop = frameloop;
    }
    /*
    update = ( w: number , h : number, devicePixelRatio: number)=> {
    this.w = w;
    this.h = h;
    this.devicePixelRatio = devicePixelRatio;
    this.camera?.resize (w,h);
      
    }*/
    /*
    setRenderer = (renderer : WebGLRenderer)=>{
        this.renderer = renderer;
        if (this.orbitControl?.set && this.camera) {
            this.orbitControl.set(this.camera.target,this.renderer.domElement );
            
        }
    }*/
    /*setControl = () => {
        if (this.orbitControl?.set && this.camera && this.renderer) {
            this.orbitControl.set(this.camera.target,this.renderer.domElement );
        }
    }*/
    addBeforeRender = (fn) => {
        this.before_render.push(fn);
    };
    setFrameloop = (frameloop = 'always') => {
        this.clock.elapsedTime = 0;
        if (frameloop !== 'never') {
            this.clock.start();
            this.clock.elapsedTime = 0;
        }
    };
    addElementScene = () => {
    };
}
