import * as THREE from 'three';
import { Camera, Object3d } from './objects';
export declare class RaycasterEvent {
    type: string;
    cancelBubble: boolean;
    originalEvent?: Event;
    coords: THREE.Vector2;
    distance: number;
    intersected: boolean;
    constructor(type: string, originalEvent: Event);
    stopPropagation(): void;
}
export declare class RaycasterManager {
    raycaster: THREE.Raycaster;
    closestObject?: Object3d;
    pointer: THREE.Vector2;
    canvas?: HTMLElement;
    camera?: THREE.Camera;
    object3d: Object3d[];
    renderer?: THREE.WebGLRenderer;
    constructor();
    onCanvas: (canvas: HTMLElement, renderer: THREE.WebGLRenderer) => void;
    dispose: () => void;
    add: (object: THREE.Object3D) => Object3d | undefined;
    update: (pointer: THREE.Vector2, camera: THREE.Camera) => void;
    checkIntersection: (object: Object3d) => void;
    dispatch: (object: Object3d, event: RaycasterEvent) => void;
    onMouseClick: (mouseEvent: MouseEvent) => void;
    onMouseDown: (mouseEvent: MouseEvent | PointerEvent) => void;
    onMouseUp: (mouseEvent: MouseEvent | PointerEvent) => void;
    onDocumentMouseMove: (mouseEvent: MouseEvent | PointerEvent) => void;
    onTouchMove: (touchEvent: TouchEvent) => void;
    onTouchStart: (touchEvent: TouchEvent) => void;
    onTouchEnd: (touchEvent: TouchEvent) => void;
}
