import type { ContextCanvas } from '../core/manager.js';
import type { Camera, Object3d } from '../core/objects';
import type { RaycasterManager } from '../core/raycaster.js';
import type { ScrollControlsState } from '../core/ScrollControls';
import type { ElementScene } from '../core/manager.js';
export declare function set_scenes(scenes: ContextCanvas): ContextCanvas;
export declare function setloadManager(LoadingManager: THREE.LoadingManager): import("three").LoadingManager;
export declare function setRaycaster(raycaster: RaycasterManager): RaycasterManager;
export declare function get_scenes(): {
    contextCanvas: ContextCanvas;
};
export declare function set_scroll(scrollControls: ScrollControlsState): ScrollControlsState;
export declare function get_scroll(): unknown;
export declare function setupScenes(self: THREE.Scene): {
    self: import("three").Scene;
    contextCanvas: ContextCanvas;
};
export declare function setElementScene(key: string, elementScene: ElementScene): {
    elementScene: ElementScene;
    contextCanvas: ContextCanvas;
};
export declare function getElementScene(key: string): {
    elementScene: ElementScene;
    contextCanvas: ContextCanvas;
};
export declare function sceneContext(key: string, scene: THREE.Scene): import("three").Scene;
export declare function setupCamera(key: string, self: Camera): {
    self: Camera;
    parent: Window;
    contextCanvas: ContextCanvas;
};
export declare function getCamera(key: string): {
    elementScene: ElementScene;
    camera: Camera;
};
export declare function setupSimplesMesh(key: string, self: any): {
    self: any;
    contextCanvas: ContextCanvas;
    elementScene: ElementScene | undefined;
    parent: import("three").Scene | undefined;
};
export declare function setupMesh(key: string, self: Object3d): {
    self: Object3d;
    parent: import("three").Scene;
    contextCanvas: ContextCanvas;
};
