import { getContext, setContext, onDestroy } from 'svelte';
const SCENE = {};
const PARENT = {};
const LOADMANAGER = {};
const RAYCASTER = {};
const SCROLL = {};
const SCENES = {};
const ELEMENTSCENES = {};
const CAMERAS = {};
export function set_scenes(scenes) {
    setContext(SCENE, scenes);
    return scenes;
}
export function setloadManager(LoadingManager) {
    setContext(LOADMANAGER, LoadingManager);
    return LoadingManager;
}
//talvez deletada
export function setRaycaster(raycaster) {
    setContext(RAYCASTER, raycaster);
    return raycaster;
}
export function get_scenes() {
    const contextCanvas = getContext(SCENE);
    return { contextCanvas };
}
export function set_scroll(scrollControls) {
    setContext(SCROLL, scrollControls);
    return scrollControls;
}
export function get_scroll() {
    const ScrollControls = getContext(SCROLL);
    return ScrollControls;
}
export function setupScenes(self) {
    const contextCanvas = getContext(SCENE);
    if (self) {
        setContext(SCENES, self);
        contextCanvas.scenes = [...contextCanvas.scenes, self];
    }
    return { self, contextCanvas };
}
export function setElementScene(key, elementScene) {
    const contextCanvas = getContext(SCENE);
    if (elementScene) {
        setContext('ELEMENTSCENES' + key, elementScene);
        contextCanvas.arrayScenes.set(key, elementScene);
        contextCanvas.arrayScenes = contextCanvas.arrayScenes;
    }
    return { elementScene, contextCanvas };
}
export function getElementScene(key) {
    const contextCanvas = getContext(SCENE);
    const elementScene = getContext('ELEMENTSCENES' + key);
    // let elementScene = contextCanvas.arrayScenes.get(key);
    return { elementScene, contextCanvas };
}
export function sceneContext(key, scene) {
    setContext(('SCENE' + key), scene);
    return scene;
}
export function setupCamera(key, self) {
    const contextCanvas = getContext(SCENE);
    let elementScene = contextCanvas.arrayScenes.get(key);
    if (elementScene != null) {
        setContext('CAMERA' + key, self);
        const parent = getContext(('SCENE' + key)) || elementScene.scene;
        parent.add(self.target);
        elementScene.camera = self;
    }
    return { self, parent, contextCanvas };
}
export function getCamera(key) {
    const elementScene = getContext('ELEMENTSCENES' + key);
    const camera = getContext('CAMERA' + key);
    return { elementScene, camera };
}
export function setupSimplesMesh(key, self) {
    let contextCanvas = getContext(SCENE);
    let parent;
    let elementScene = contextCanvas.arrayScenes.get(key);
    if (elementScene != null) {
        parent = getContext(('SCENE' + key)) || elementScene.scene;
        parent.add(self);
    }
    return { self, contextCanvas, elementScene, parent };
}
export function setupMesh(key, self) {
    let contextCanvas = getContext(SCENE);
    const parent = contextCanvas.scene;
    if (self) {
        setContext(PARENT, self);
        parent.add(self.target);
        contextCanvas.object3d = [...contextCanvas.object3d, self];
        let value = contextCanvas.arrayScenes.get(key);
        if (value) {
            value.scene.add(self.target);
        }
    }
    return { self, parent, contextCanvas };
}
